Index: gcc/ChangeLog
===================================================================
--- gcc/ChangeLog	(.../tags/gcc_5_3_0_release)	(wersja 231276)
+++ gcc/ChangeLog	(.../branches/gcc-5-branch)	(wersja 231276)
@@ -1,3 +1,7 @@
+2015-12-04  Richard Biener  <rguenther@suse.de>
+
+	* BASE-VER: Set to 5.3.1.
+
 2015-12-04  Release Manager
 
 	* GCC 5.3.0 released.
Index: gcc/testsuite/g++.dg/template/pr67337.C
===================================================================
--- gcc/testsuite/g++.dg/template/pr67337.C	(.../tags/gcc_5_3_0_release)	(nonexistent)
+++ gcc/testsuite/g++.dg/template/pr67337.C	(.../branches/gcc-5-branch)	(wersja 231276)
@@ -0,0 +1,25 @@
+template <class> class A
+{
+  void m_fn1 (int *, int);
+};
+
+template <class> class B
+{
+public:
+  typedef int Type;
+};
+
+template <class> class C
+{
+public:
+  C (int);
+  template <template <class> class T> void m_fn2 (typename T<void>::Type);
+};
+
+template <>
+void
+A<int>::m_fn1 (int *, int)
+{
+  C<int> a (0);
+  a.m_fn2<B> (0);
+}
Index: gcc/cp/ChangeLog
===================================================================
--- gcc/cp/ChangeLog	(.../tags/gcc_5_3_0_release)	(wersja 231276)
+++ gcc/cp/ChangeLog	(.../branches/gcc-5-branch)	(wersja 231276)
@@ -1,3 +1,8 @@
+2015-12-04  Markus Trippelsdorf  <markus@trippelsdorf.de>
+
+	PR c++/67337
+	* mangle.c (write_template_prefix): Guard against context==NULL.
+
 2015-12-04  Release Manager
 
 	* GCC 5.3.0 released.
Index: gcc/cp/mangle.c
===================================================================
--- gcc/cp/mangle.c	(.../tags/gcc_5_3_0_release)	(wersja 231276)
+++ gcc/cp/mangle.c	(.../branches/gcc-5-branch)	(wersja 231276)
@@ -1160,7 +1160,7 @@
      So, for the example above, `Outer<int>::Inner' is represented as a
      substitution candidate by a TREE_LIST whose purpose is `Outer<int>'
      and whose value is `Outer<T>::Inner<U>'.  */
-  if (TYPE_P (context))
+  if (context && TYPE_P (context))
     substitution = build_tree_list (context, templ);
   else
     substitution = templ;
Index: gcc/BASE-VER
===================================================================
--- gcc/BASE-VER	(.../tags/gcc_5_3_0_release)	(wersja 231276)
+++ gcc/BASE-VER	(.../branches/gcc-5-branch)	(wersja 231276)
@@ -1 +1 @@
-5.3.0
+5.3.1
